def cardinality(span):
    return int(span[1])-int(span[0])+1

def overlap(span1, span2):
    if int(span1[0]) <= int(span2[1]) and int(span1[1]) >= int(span2[0]):
        if subsume(span1,span2):
            return cardinality(span1)
        elif subsume(span2,span1):
            return cardinality(span2)
        elif int(span1[0]) > int(span2[0]):
            return int(span2[1]) - int(span1[0]) + 1
        else:
            return int(span1[1]) - int(span2[0]) + 1
    else:
        return False

def subsume(span1, span2):

    if int(span1[0]) >= int(span2[0]) and int(span1[1]) <= int(span2[1]):
        return True

    else:
        return False

def intersect(span1, span2):
    olap_total = 0
    
    for span11 in span1:
        for span22 in span2:
            olap = overlap(span11, span22)

            if olap:
                olap_total += olap

    if olap_total > 0:
        return olap_total
    else:
        return False

def union(spans):
    span_union = []

    for span in spans:
        for span1 in span:
            span1[0] = int(span1[0])
            span1[1] = int(span1[1])
    
    span_union = spans[0]

    for i in range(1,len(spans)):
        
        for bi in range(len(spans[i])):
            olaps = []
            olap_bounds = []

            for bu in range(len(span_union)):
                
                if overlap(spans[i][bi], span_union[bu]):
                    olaps.append(bu)
                    olap_bounds.extend(span_union[bu])

            if olaps:
                olap_bounds.extend(spans[i][bi])
                new_span = [min(olap_bounds), max(olap_bounds)]

                olaps.reverse()
                for idx in olaps:
                    span_union.pop(idx)

                span_union.append(new_span)
                
                del olaps[:]
                del olap_bounds[:]
            else:
                span_union.append(spans[i][bi])
            
            span_union.sort(lambda x,y: x[0]-y[0])

    return span_union

def subtract(span1, spans2):
    "subtract spans2 from span1"

    span2_union = union(spans2)

    for span2 in span2_union:
        if subsume(span1, span2):
            return False

    if int(span1[0]) < int(span2_union[0][0]):
        span2_union.insert(0, [int(span1[0])-2, int(span1[0])-1])

    if int(span1[1]) > int(span2_union[-1][1]):
        span2_union.append([int(span1[1])+1, int(span1[1])+2])

    span2_reverse = []
    for i in range(len(span2_union)-1):
        s1 = span2_union[i]
        s2 = span2_union[i+1]

        span2_reverse.append([s1[1]+1, s2[0]-1])

    return span2_reverse
