#!/bin/bash

# submit BAC pool alignment jobs for all reference sequences
# at the same time. Run this from the poolanalysis_v# directory

# Usage: submitjobs.pl 45 
# where 45 is the k value

set -eux

#l=$1
dir=$1
file=$2
name=$3
mem=$4
mqsub=/opt/mqtools/bin/mqsub


# Log into apollo and submit.
ssh apollo \
	"cd $dir && $mqsub --qsub '-l mem_free=$mem -l mem_token=$mem -q all.q -l hostname=q*' --file $file --name $name"

exit
